import { world, system, Player } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
//Code by: FreinerG2Co
//Youtube: https://www.youtube.com/channel/UCDURk4uaE1bavTaMgr0SWvg
function menus(player) {
    const menu = new ActionFormData()

    menu.title("Admin Panel")
    menu.button("Ban Player", "textures/blocks/barrier")
    menu.button("Mute Player", "textures/ui/mute_on")
    menu.button("Freeze Player", "textures/blocks/ice")
    menu.button("Player Game Mode", "textures/ui/icon_steve")
    menu.button("Player Effects", "textures/ui/poison_effect")
    menu.button("Teleport Player", "textures/ui/world_glyph_color_2x_black_outline")
    menu.button("Clear Player Inventory", "textures/blocks/chest_front")
    menu.button("World Time", "textures/ui/timer")
    menu.show(player).then(r => {
        if (r.selection === 0) {
            ban(player)
        }
        if (r.selection === 1) {
            mute(player)
        }
        if (r.selection === 2) {
            freeze(player)
        }
        if (r.selection === 3) {
            gm(player);
        }
        if (r.selection === 4) {
            applyEffect(player)
        }
        if (r.selection === 5) {
            teleport(player)
        }
        if (r.selection === 6) {
            clearInventory(player)
        }
        if (r.selection === 7) {
            controlWeatherAndTime(player)
        }
    });
}
function menu2(player) {
    const opmenu = new ActionFormData()
    opmenu.title("Admin Panel OP")
    opmenu.button("Ban Player", "textures/blocks/barrier")
    opmenu.button("Mute Player", "textures/ui/mute_on")
    opmenu.button("Freeze Player", "textures/blocks/ice")
    opmenu.button("Player Game Mode", "textures/ui/icon_steve")
    opmenu.button("Player Effects", "textures/ui/poison_effect")
    opmenu.button("Teleport Player", "textures/ui/world_glyph_color_2x_black_outline")
    opmenu.button("Clear Player Inventory", "textures/blocks/chest_front")
    opmenu.button("World Time", "textures/ui/timer")
    opmenu.button("Give panel access to other players", "textures/ui/FriendsDiversity")
    opmenu.show(player).then(r => {
        if (r.selection === 0) {
            ban(player)
        }
        if (r.selection === 1) {
            mute(player)
        }
        if (r.selection === 2) {
            freeze(player)
        }
        if (r.selection === 3) {
            gm(player);
        }
        if (r.selection === 4) {
            applyEffect(player)
        }
        if (r.selection === 5) {
            teleport(player)
        }
        if (r.selection === 6) {
            clearInventory(player)
        }
        if (r.selection === 7) {
            controlWeatherAndTime(player)
        }
        if (r.selection === 8) {
            addops(player)
        }
    });
}
function addops(player) {
    let addop = new ModalFormData()
    addop.title("Panel Players access");
    addop.textField("Player Name", "");
    addop.toggle("Remove permissions")
    addop.show(player).then(r => {
        if (r.formValues[1] == false) {
            player.runCommand('tag @a[name="' + r.formValues[0] + '"] add admin')
            player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
            player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§aYou have been granted access to player ' + r.formValues[0] + '"}]}')
            player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[name="' + r.formValues[0] + '"] {"rawtext":[{"selector":"@s"},{"text":"§a has granted you access to the administrator panel§r"}]}')
        } else {
            player.runCommand('tag @a[name="' + r.formValues[0] + '"]remove admin')
            player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
            player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§aYou have been remove permissions to player ' + r.formValues[0] + '"}]}')
            player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[name="' + r.formValues[0] + '"] {"rawtext":[{"selector":"@s"},{"text":"§4 you have lost access to the administrator panel§r"}]}')
        }
    });
}
function ban(player) {
    let banm = new ModalFormData()
    banm.title("Ban Player");
    banm.textField("Player Name", "")
    banm.textField("Reason", "Hacks", "Hacks")
    banm.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else {
            let form = new MessageFormData();
            form.title("Confirmation");
            form.body("You are sure you want to ban the player " + r.formValues[0]);
            form.button1("Yes");
            form.button2("No");
            form.show(player).then(x => {
                if (x.selection == 0) {
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run kick "' + r.formValues[0] + '" Reason: ' + r.formValues[1])
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player ' + r.formValues[0] + ' has been banned by "},{"selector":"@s"}]}')
                    player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                }
            });
        }

    });
}
function mute(player) {
    let mutem = new ModalFormData()
    mutem.title("Mute Player");
    mutem.textField("Selector/Player Name", "")
    mutem.textField("Reason", "", "Bad words")
    mutem.toggle("Remove Mute", false)
    mutem.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else if (r.formValues[2] == false) {
            let form = new MessageFormData();
            form.title("Confirmation");
            form.body("You are sure you want to mute the player " + r.formValues[0]);
            form.button1("Yes");
            form.button2("No");
            form.show(player).then(x => {
                if (x.selection == 0) {
                    if (!r.formValues[0].includes('@')) {
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tag @a[name="' + r.formValues[0] + '"] add shh')
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player ' + r.formValues[0] + ' has been muted by "},{"selector":"@s"}]}')
                        player.runCommand('execute as @a[name="' + r.formValues[0] + '",c=1] at @s run /tellraw @s {"rawtext":[{"text":"§4You have been silenced by ' + player.name + ', ' + r.formValues[1] + '"}]}')
                        player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                    } else {
                        player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tag ' + r.formValues[0] + ' add shh')
                        player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player "}, {"selector":"' + r.formValues[0] + '"},{"text":" has been muted by "},{"selector":"@s"}]}')
                        player.runCommand('execute as ' + r.formValues[0] + ' at @s run /tellraw @s {"rawtext":[{"text":"§4You have been silenced by ' + player.name + ', ' + r.formValues[1] + '"}]}')
                        player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                    }
                }
            });
        } else {
            if (!r.formValues[0].includes('@')) {
                player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tag @a[name="' + r.formValues[0] + '"] remove shh')
                player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player ' + r.formValues[0] + ' has been unmuted by "},{"selector":"@s"}]}')
                player.runCommand('execute as @a[name="' + r.formValues[0] + '",c=1] at @s run /tellraw @s {"rawtext":[{"text":"§aYou have been unmuted by ' + player.name + '"}]}')
                player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
            } else {
                player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tag ' + r.formValues[0] + ' remove shh')
                player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player "}, {"selector":"' + r.formValues[0] + '"},{"text":" has been unmuted by "},{"selector":"@s"}]}')
                player.runCommand('execute as ' + r.formValues[0] + ' at @s run /tellraw @s {"rawtext":[{"text":"§aYou have been unmuted by ' + player.name + '"}]}')
                player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
            }
        }
    });
}
//Freeze----------------------------------
function freeze(player) {
    let freezem = new ModalFormData()
    freezem.title("Freeze Player");
    freezem.textField("Selector/Player Name", "")
    freezem.textField("Reason", "", "Misconduct")
    freezem.toggle("Remove Freeze", false)
    freezem.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else if (r.formValues[2] == false) {
            let form = new MessageFormData();
            form.title("Confirmation");
            form.body("You are sure you want to freeze the player " + r.formValues[0]) + '"';
            form.button1("Yes");
            form.button2("No");
            form.show(player).then(x => {
                if (x.selection == 0) {
                    if (x.selection == 0 && !r.formValues[0].includes('@')) {
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tag @a[name="' + r.formValues[0] + '"] add freeze')
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player ' + r.formValues[0] + ' has been freeze by "},{"selector":"@s"}]}')
                        player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                        player.runCommand('execute as @a[name="' + r.formValues[0] + '",c=1] at @s run /tellraw @s {"rawtext":[{"text":"§bYou have been freeze by ' + player.name + ', ' + r.formValues[1] + '"}]}')
                    } else if (x.selection == 0 && r.formValues[0].includes('@')) {
                        player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tag ' + r.formValues[0] + ' add freeze')
                        player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player "}, {"selector":"' + r.formValues[0] + '"}, {"text":" has been freeze by "},{"selector":"@s"}]}')
                        player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                        player.runCommand('execute as ' + r.formValues[0] + ' at @s run /tellraw @s {"rawtext":[{"text":"§bYou have been freeze by ' + player.name + ', ' + r.formValues[1] + '"}]}')
                    }

                }
            });
        } else {
            if (!r.formValues[0].includes('@')) {
                player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tag @a[name="' + r.formValues[0] + '"] remove freeze')
                player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player ' + r.formValues[0] + ' has been unfreeze by "},{"selector":"@s"}]}')
                player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                player.runCommand('execute as @a[name="' + r.formValues[0] + '",c=1] at @s run /tellraw @s {"rawtext":[{"text":"§aYou have been unfreeze by ' + player.name + '"}]}')
            } else if (r.formValues[0].includes('@')) {
                player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tag ' + r.formValues[0] + ' remove freeze')
                player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The player "}, {"selector":"' + r.formValues[0] + '"}, {"text":" has been unfreeze by "},{"selector":"@s"}]}')
                player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                player.runCommand('execute as ' + r.formValues[0] + ' at @s run /tellraw @s {"rawtext":[{"text":"§aYou have been unfreeze by ' + player.name + '"}]}')
            }
        }
    });
}
//Game Mode---------------------------------------
function gm(player) {
    let gamem = new ModalFormData;
    let gmList = ["Survival", "Creative", "Adventure", "Spectator"]
    gamem.title("Player GameMode");
    gamem.textField("Selector/Player Name", "");
    gamem.dropdown("Game Mode", gmList)
    gamem.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else {
            let form = new MessageFormData();
            form.title("Confirmation");
            form.body("You are sure you want to change the game mode of the player " + r.formValues[0]) + '"';
            form.button1("Yes");
            form.button2("No");
            form.show(player).then(x => {

                if (x.selection == 0 && !r.formValues[0].includes('@')) {
                    player.runCommand('execute as @s at @s if entity @a[ name="' + r.formValues[0] + '",c=1] run gamemode ' + gmList[r.formValues[1]] + ' @a[name="' + r.formValues[0] + '"]')
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @a[tag=admin] {"rawtext":[{"text":"§6The game mode of the player ' + r.formValues[0] + ' has been changed to ' + gmList[r.formValues[1]] + '"}]}')
                    player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')

                } else if (x.selection == 0 && r.formValues[0].includes('@')) {
                    player.runCommand('gamemode ' + gmList[r.formValues[1]] + ' ' + r.formValues[0])
                    player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§6The game mode of the player "}, {"selector":"' + r.formValues[0] + '"}, {"text":" has been changed to ' + gmList[r.formValues[1]] + '"}]}')
                    player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                }
            });
        }
    });
}
//--------------------Efectos----------------------
function applyEffect(player) {
    let effectForm = new ModalFormData;
    let effectList = ["Speed", "Slowness", "Haste", "Mining Fatigue", "Strength", "Instant Health", "Instant Damage", "Jump Boost", "Nausea", "Regeneration", "Resistance", "Fire Resistance", "Water Breathing", "Invisibility", "Blindness", "Night Vision", "Hunger", "Weakness", "Poison", "Wither", "Health Boost", "Absorption", "Saturation", "Levitation", "Bad Luck", "Fatal Poison", "Slow Falling", "Conduit Power", "Bad Omen", "Village Hero", "Darkness"];
    effectForm.title("Apply Effect to Player");
    effectForm.textField("Selector/Player Name", "");
    effectForm.dropdown("Effect", effectList);
    effectForm.slider("Effect Level", 0, 255, 1);
    effectForm.textField("Effect Duration", "");

    effectForm.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else {
            let confirmForm = new MessageFormData();
            confirmForm.title("Confirmation");
            confirmForm.body("You are sure you want to apply " + effectList[r.formValues[1]] + " to the player " + r.formValues[0]);
            confirmForm.button1("Yes");
            confirmForm.button2("No");

            confirmForm.show(player).then(x => {
                if (x.selection == 0 && !r.formValues[0].includes('@') && r.formValues[3] <= 999999999) {
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run effect "' + r.formValues[0] + '" ' + effectList[r.formValues[1]].toLowerCase().replace(" ", "_") + ' ' + r.formValues[3] + ' ' + r.formValues[2])
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§aThe effect ' + effectList[r.formValues[1]].toLowerCase().replace(" ", "_") + ' has been applied to ' + r.formValues[0] + '"}]}')
                    player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                } else if (x.selection == 0 && r.formValues[0].includes('@') && r.formValues[3] <= 999999999) {

                    player.runCommand('effect ' + r.formValues[0] + ' ' + effectList[r.formValues[1]].toLowerCase().replace(" ", "_") + ' ' + r.formValues[3] + ' ' + r.formValues[2])
                    player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§aThe effect ' + effectList[r.formValues[1]].toLowerCase().replace(" ", "_") + ' has been applied to ' + r.formValues[0] + '"}]}')
                    player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}')
                }
                if (r.formValues[3] > 999999999) {
                    player.runCommand('/tellraw @s {"rawtext":[{"text":"§4The duration of the effect is very long§r"}]}')
                }
            });
        }
    });
}
//-----------------------tp-------------------------
function teleport(player) {
    let teleportForm = new ModalFormData;
    teleportForm.title("Teleportation Command");
    teleportForm.textField("Teleport Who (Player/Selector)", "");
    teleportForm.textField("Teleport Where (Player/Coordinates)", "");

    teleportForm.show(player).then(r => {
        if (r.formValues[0] == "" || r.formValues[1] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4One or both of the fields are empty"}]}')
        } else {
            let confirmForm = new MessageFormData();
            confirmForm.title("Confirmation");
            confirmForm.body("You are sure you want to teleport " + r.formValues[0] + " to " + r.formValues[1]);
            confirmForm.button1("Yes");
            confirmForm.button2("No");

            confirmForm.show(player).then(x => {
                if (x.selection == 0) {
                    if (!r.formValues[1].includes(",") && !r.formValues[1].includes("@") && !r.formValues[0].includes(",") && !r.formValues[0].includes("@") && !/\d/.test(r.formValues[0])) {
                        // Destination is a set of coordinates or a player/selector
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '"] run tp @a[name="' + r.formValues[0] + '"] ' + r.formValues[1])
                        player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '"] run tellraw @s {"rawtext":[{"text":"§4' + r.formValues[0] + ' has been teleported to ' + r.formValues[1] + '"}]}')
                        player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '"] run tellraw @s {"rawtext":[{"text":"§4Player to teleport not found"}]}')
                        if (!/\d/.test(r.formValues[1])) {
                            player.runCommand('execute as @s at @s unless entity ' + r.formValues[1] + ' run tellraw @s {"rawtext":[{"text":"§4Destination player not found"}]}')
                        }
                    } else if (r.formValues[0].includes("@") && /\d/.test(r.formValues[1])) {
                        player.runCommand('tp ' + r.formValues[0] + ' ' + r.formValues[1])
                        player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player to teleport not found"}]}')
                        player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§6"},{"selector":"' + r.formValues[0] + '"},' + '{"text":" has been teleported to ' + r.formValues[1] + '"}]}')
                    } else {
                        player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '",c=1] run tellraw @s {"rawtext":[{"text":"§4Player to teleport not found"}]}')
                    }
                }
            });
        }
    });
}
function clearInventory(player) {
    let clearForm = new ModalFormData;
    clearForm.title("Clear Inventory");
    clearForm.textField("Player/Selector to clear inventory", "");

    clearForm.show(player).then(r => {
        if (r.formValues[0] == "") {
            player.runCommand('tellraw @s {"rawtext":[{"text":"§4The player field is empty"}]}')
        } else {
            let confirmForm = new MessageFormData();
            confirmForm.title("Confirmation");
            confirmForm.body("You are sure you want to clear the inventory of " + r.formValues[0]);
            confirmForm.button1("Yes");
            confirmForm.button2("No");

            confirmForm.show(player).then(x => {
                if (x.selection == 0 && r.formValues[0].includes("@")) {
                    player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run clear ' + r.formValues[0]);
                    player.runCommand('execute as @s at @s if entity ' + r.formValues[0] + ' run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The inventory of "}, {"selector":"' + r.formValues[0] + '"}, {"text":" has been cleared"}]}');
                    player.runCommand('execute as @s at @s unless entity ' + r.formValues[0] + ' run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}');
                } else if (x.selection == 0 && !r.formValues[0].includes("@")) {
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '"] run clear @a[name="' + r.formValues[0] + '"]');
                    player.runCommand('execute as @s at @s if entity @a[name="' + r.formValues[0] + '"] run tellraw @a[tag=admin] {"rawtext":[{"text":"§4The inventory of ' + r.formValues[0] + '"}, {"text":" has been cleared"}]}');
                    player.runCommand('execute as @s at @s unless entity @a[name="' + r.formValues[0] + '"] run tellraw @s {"rawtext":[{"text":"§4Player not found"}]}');
                }
            });
        }
    });
}
function controlWeatherAndTime(player) {
    let controlForm = new ModalFormData;
    controlForm.title("Weather and Time Control");
    let weatherList = ["clear", "rain", "thunder"];
    let timeList = ["day", "night"];
    controlForm.dropdown("Weather", weatherList);
    controlForm.dropdown("Time of Day", timeList);
    controlForm.toggle("Daylight cycle", true)
    controlForm.toggle("Do weather cycle", true)

    controlForm.show(player).then(r => {
        let confirmForm = new MessageFormData();
        confirmForm.title("Confirmation");
        confirmForm.body("You are sure you want to change the weather to " + weatherList[r.formValues[0]] + " and set the time to " + timeList[r.formValues[1]] + ", Daylight cycle set to: " + r.formValues[2] + ", Do weather cycle: " + r.formValues[3]);
        confirmForm.button1("Yes");
        confirmForm.button2("No");

        confirmForm.show(player).then(x => {
            if (x.selection == 0) {
                player.runCommand('weather ' + weatherList[r.formValues[0]]);
                player.runCommand('time set ' + timeList[r.formValues[1]]);
                player.runCommand('tellraw @s {"rawtext":[{"text":"§6Weather set to ' + weatherList[r.formValues[0]] + ', time set to ' + timeList[r.formValues[1]] + ', Daylight cycle set to: ' + r.formValues[2] + ', Do weather cycle set to: ' + r.formValues[3] + '"}]}');
                if (r.formValues[2] == true) {
                    player.runCommand('gamerule dodaylightcycle true')
                } else {
                    if (r.formValues[2] == false) {
                        player.runCommand('gamerule dodaylightcycle false')
                    }
                }
                if (r.formValues[3] == true) {
                    player.runCommand('gamerule doweathercycle true')
                } else {
                    if (r.formValues[3] == false) {
                        player.runCommand('gamerule doweathercycle false')
                    }
                }
            }
        });
    });
}

world.beforeEvents.chatSend.subscribe((eventData) => {
    eventData.cancel = true;
    let { sender, message, } = eventData
    system.run(() => {
        if (sender.hasTag('shh') == true) {
            sender.runCommand('tellraw @s {"rawtext":[{"text":"§cYou have been silenced!"}]}')
            sender.runCommand('tellraw @a[tag=admin] {"rawtext":[{"text":"-§6"},{"selector":"@s"},{"text":" is trying to say something (Player muted)"}]}')
        } else {
            sender.runCommand('tellraw @a {"rawtext":[{"text":"<"},{"selector":"@s"},{"text":"> ' + message + '"}]}')
        }
    });


});
world.beforeEvents.itemUse.subscribe((eventData) => {
    let player = eventData.source
    let itemUse = eventData.itemStack.typeId
    if (itemUse == "minecraft:compass" && player.hasTag("admin") || player.isOp()) {
        system.run(() => {
            if (player.hasTag('admin') && !player.isOp() && itemUse == "minecraft:compass") {
                menus(player)
            }
            if (player.isOp() && itemUse == "minecraft:compass") {
                menu2(player)
            }

        });
    }
});
world.afterEvents.entityHurt.subscribe((eventData) => {
    let player = eventData.hurtEntity
    let damager = eventData.damageSource.damagingEntity
    if (!damager) return;
    let item = damager.getComponent("inventory")?.container.getItem(damager.selectedSlot)

    if (player.typeId == "minecraft:player" && damager.typeId == "minecraft:player" && item != undefined) {
        if (item.typeId == "minecraft:ice" && damager.hasTag('admin') || damager.isOp()) {
            if (item.typeId == "minecraft:ice") {
                if (player.hasTag('freeze')) {
                    player.runCommand('tag @s remove freeze')
                } else if (!player.hasTag('freeze')) {
                    player.runCommand('tellraw @a[tag=admin] {"rawtext":[{"text":"§bThe player ' + player.name + ' has been frozen by ' + damager.name + '"}]}')
                    player.runCommand('tag @s add freeze')
                    player.runCommand('/tellraw @s {"rawtext":[{"text":"§bYou have been freeze by ' + damager.name + '"}]}')
                }

            }
        }

    }

});

system.runInterval(() => {

    for (const player of world.getPlayers()) {
        if (player.hasTag("admin") || player.isOp()) {
            if (player.isOp()) {
                player.nameTag = `§d[ADMIN]§r ${player.name}`
                player.removeTag('shh')
                player.removeTag('freeze')
                player.addTag('admin')
            } else {
                player.nameTag = `§b[HELPER]§r ${player.name}`
            }

        } else {
            player.nameTag = `${player.name}`
        }
    }
}, 20);